# frozen_string_literal: true

# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Auto-generated by gapic-generator-ruby. DO NOT EDIT!

require "gapic/common"
require "gapic/config"
require "gapic/config/method"

require "google/cloud/bigquery/storage/v1/version"

require "google/cloud/bigquery/storage/v1/big_query_read/credentials"
require "google/cloud/bigquery/storage/v1/big_query_read/paths"
require "google/cloud/bigquery/storage/v1/big_query_read/client"

module Google
  module Cloud
    module Bigquery
      module Storage
        module V1
          ##
          # BigQuery Read API.
          #
          # The Read API can be used to read data from BigQuery.
          #
          # To load this service and instantiate a client:
          #
          #     require "google/cloud/bigquery/storage/v1/big_query_read"
          #     client = ::Google::Cloud::Bigquery::Storage::V1::BigQueryRead::Client.new
          #
          module BigQueryRead
          end
        end
      end
    end
  end
end

helper_path = ::File.join __dir__, "big_query_read", "helpers.rb"
require "google/cloud/bigquery/storage/v1/big_query_read/helpers" if ::File.file? helper_path
